/*
 * Common powerpc suspend code for 32 and 64 bits
 *
 * Copyright 2007	Johannes Berg <johannes@sipsolutions.net>
 *
 * GPLv2
 */

#include <linux/sched.h>
#include <asm/suspend.h>
#include <asm/cputable.h>
#include <asm/system.h>
#include <asm/current.h>
#include <asm/mmu_context.h>

#ifdef CONFIG_SPE
extern void enable_kernel_spe(void);
#endif

void save_processor_state(void)
{
	/* Giveup the lazy FPU & vec so we don't have to back them
	 * up from the low level code
	 */
	enable_kernel_fp();

#ifdef CONFIG_ALTIVEC
	if (cur_cpu_spec->cpu_features & CPU_FTR_ALTIVEC)
		enable_kernel_altivec();
#endif /* CONFIG_ALTIVEC */

#ifdef CONFIG_SPE
	enable_kernel_spe();
#endif
}

void restore_processor_state(void)
{
#ifdef CONFIG_PPC32
	set_context(current->active_mm->context.id, current->active_mm->pgd);
#endif
}
